import { world, system } from '@minecraft/server'
//variant values to bucket
const variantBucket = new Map()
variantBucket.set("0", 'frogsinbuckets:bucket_frog_temperate')
variantBucket.set("1", 'frogsinbuckets:bucket_frog_cold')
variantBucket.set("2", 'frogsinbuckets:bucket_frog_warm')
//interact with entity
world.afterEvents.playerInteractWithEntity.subscribe((data) => {
    const player = data.player
    const entity = data.target
    const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlot)
    if (item.typeId == 'minecraft:bucket' && entity.typeId == 'minecraft:frog') {
        const variant = entity.getComponent("minecraft:variant").value
        entity.runCommand('playsound bucket.fill_fish @a[r=8] ~~~ 1 1 1')
        if (item.amount > 1) {
            player.runCommand('give @s ' + variantBucket.get("" + variant))
            player.runCommand('clear @s bucket 0 1')
        } else {
            player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 ' + variantBucket.get("" + variant) + ' 1 0')
        }
        entity.remove()
    }
})
//onPlayerPlaceBlock
world.afterEvents.playerPlaceBlock.subscribe((data) => {
    const block = data.block
    const player = data.player
    const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlot)
    if (block.typeId == 'frogsinbuckets:place_frog_cold') {
        player.runCommand('setblock ' + block.x + ' ' + block.y + ' ' + block.z + ' air')
        player.runCommand('summon frog ' + block.x + ' ' + block.y + ' ' + block.z + ' ~ ~ spawn_cold')
        player.runCommand('playsound bucket.empty_fish @a[r=8] ' + block.x + ' ' + block.y + ' ' + block.z + ' 1 1 1')
        if (item == undefined) {
            player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 bucket 1 0')
        } else {
            player.runCommand('give @s bucket 1 0')
        }
    }
    if (block.typeId == 'frogsinbuckets:place_frog_warm') {
        player.runCommand('setblock ' + block.x + ' ' + block.y + ' ' + block.z + ' air')
        player.runCommand('summon frog ' + block.x + ' ' + block.y + ' ' + block.z + ' ~ ~ spawn_warm')
        player.runCommand('playsound bucket.empty_fish @a[r=8] ' + block.x + ' ' + block.y + ' ' + block.z + ' 1 1 1')
        if (item == undefined) {
            player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 bucket 1 0')
        } else {
            player.runCommand('give @s bucket 1 0')
        }
    }
    if (block.typeId == 'frogsinbuckets:place_frog_temperate') {
        player.runCommand('setblock ' + block.x + ' ' + block.y + ' ' + block.z + ' air')
        player.runCommand('summon frog ' + block.x + ' ' + block.y + ' ' + block.z + ' ~ ~ spawn_temperate')
        player.runCommand('playsound bucket.empty_fish @a[r=8] ' + block.x + ' ' + block.y + ' ' + block.z + ' 1 1 1')
        if (item == undefined) {
            player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 bucket 1 0')
        } else {
            player.runCommand('give @s bucket 1 0')
        }
    }
})